#include <dkmem.h>
#include <dkapp.h>
#include <stdio.h>
#if DK_HAVE_STDLIB_H
#include <stdlib.h>
#endif

static char pkgname[]= { "hello" };
static char sysconfdir[] = { "/etc" };

static int success = 0;

static dk_key_value_t kv[] = {
  { "hello",	"Hello world!" },
  { "goodbye",	"Goodbye world!" }
};
static size_t szkv = sizeof(kv)/sizeof(dk_key_value_t);

int main(int argc, char *argv[]) {
  dk_app_t *app = NULL;
  char **msg = NULL;
  app = dkapp_open_ext1(argc, argv, pkgname, sysconfdir, 0, 0);
  if(app) {
    msg = dkapp_find_key_value(app, kv, szkv, "h03msg");
    if(msg) {
      success = 1;
      printf("%s\n", msg[0]);
      printf("%s\n", msg[1]);
      dk_delete(msg);
    }
    dkapp_close(app); app = NULL;
  }
  success = (success ? 0 : 1);
  exit(success);
  return success;
}
