#include <dkmem.h>
#include <dkapp.h>
#include <stdio.h>
#if DK_HAVE_STDLIB_H
#include <stdlib.h>
#endif

static char pkgname[]= { "hello" };
static char sysconfdir[] = { "/etc" };
static char space[] = { " " };

static int success = 0;

int main(int argc, char *argv[]) {
  dk_app_t *app = NULL;
  int i, my_argc;
  char *cmdline, **my_argv, **lfdptr;
  size_t lgt;
  app = dkapp_open_ext1(argc, argv, pkgname, sysconfdir, 0, 0);
  if(app) {
    success = 1;
    my_argc = dkapp_get_argc(app);
    my_argv = dkapp_get_argv(app);
    lfdptr = my_argv;
    i = 0; lgt = 0;
    while(i < my_argc) {
      if(*lfdptr) {
        lgt += strlen(*lfdptr);
      }
      i++; lfdptr++;
    }
    lgt += my_argc;
    cmdline = dk_new(char,lgt);
    if(cmdline) {
      lfdptr = my_argv; i = 0;
      while(i < my_argc) {
        if(*lfdptr) {
	  if(i > 0) {
	    strcat(cmdline, space);
	    strcat(cmdline, *lfdptr);
	  } else {
	    strcpy(cmdline, *lfdptr);
	  }
	  i++; lfdptr++;
	}
      }
      printf("Command line: %s\n", cmdline);
      dk_delete(cmdline);
    }
    dkapp_close(app); app = NULL;
  }
  success = (success ? 0 : 1);
  exit(success);
  return success;
}
