/*
Copyright (c) 2008, Dirk Krause
All rights reserved.

Redistribution and use in source and binary forms,
with or without modification, are permitted provided
that the following conditions are met:

* Redistributions of source code must retain the above
  copyright notice, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  opyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.
* Neither the name of the Dirk Krause nor the names of
  its contributors may be used to endorse or promote
  products derived from this software without specific
  prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
DAMAGE.
*/


package traceccgui;

// jlayout.import.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Dimension;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemListener;
import javax.swing.JComponent;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.WindowConstants;
import javax.swing.BorderFactory;
import javax.swing.border.TitledBorder;
// END OF JLAYOUT SECTION
// jlayout.import.end

import javax.swing.JDialog;
import javax.swing.JFrame;
import dirk_krause.jtools.GuiController;
import dirk_krause.jtools.StringTool;
/**
 *
 * @author krause
 */
public class TraceccOptionsDialog extends JDialog
	implements ActionListener, ItemListener
{
  private TraceccController tc = null;
  private GuiController gc = null;
  private int b = 5;

// jlayout.variables.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private int jLayoutSizeMinX = 0;
	private int jLayoutSizeMinY = 0;
	private int jLayoutSizePrefX = 0;
	private int jLayoutSizePrefY = 0;
	private int jLayoutSizeMaxX = 0;
	private int jLayoutSizeMaxY = 0;
	JButton bCancel = null;
	JButton bDefaults = null;
	JButton bOK = null;
	JButton bReset = null;
	JCheckBox cbAlwaysOpenLog = null;
	JCheckBox cbCplusplus = null;
	JComboBox cbDebugChooseIde = null;
	JCheckBox cbDebugIde = null;
	JCheckBox cbDebugStdout = null;
	JCheckBox cbDebugTime = null;
	JCheckBox cbDebugTraceKey = null;
	JCheckBox cbDoDebug = null;
	JCheckBox cbFtCpt = null;
	JCheckBox cbFtCtr = null;
	JCheckBox cbFtJl = null;
	JCheckBox cbFtJtr = null;
	JCheckBox cbFtMtr = null;
	JCheckBox cbLineNumbers = null;
	JCheckBox cbMakeMode = null;
	JLabel l1FtCpt = null;
	JLabel l1FtCtr = null;
	JLabel l1FtJl = null;
	JLabel l1FtJtr = null;
	JLabel l1FtMtr = null;
	JLabel l2FtCpt = null;
	JLabel l2FtCtr = null;
	JLabel l2FtJl = null;
	JLabel l2FtJtr = null;
	JLabel l2FtMtr = null;
	JLabel lOutputWidth = null;
	JPanel pButtons = null;
	JPanel pDebugOptions = null;
	JPanel pDummy1 = null;
	JPanel pDummy2 = null;
	JPanel pFiles = null;
	JPanel pGeneralOptions = null;
	JPanel pOutputOptions = null;
	JTextField tfOutputWidth = null;
// END OF JLAYOUT SECTION
// jlayout.variables.end

// jlayout.setup.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	/**
	 * Reset the stored size informatio.
	 */
	private void jLayoutResetSizes()
	{
	  jLayoutSizeMinX = 0; jLayoutSizeMinY = 0;
	  jLayoutSizeMaxX = 0; jLayoutSizeMaxY = 0;
	  jLayoutSizePrefX = 0; jLayoutSizePrefY = 0;
	}
	private void jLayoutGetSize(JComponent c)
	{
	  Dimension d;
	  d = c.getMinimumSize();
	  if(d.width > jLayoutSizeMinX) { jLayoutSizeMinX = d.width; }
	  if(d.height > jLayoutSizeMinY) { jLayoutSizeMinY = d.height; }
	  d = c.getPreferredSize();
	  if(d.width > jLayoutSizePrefX) { jLayoutSizePrefX = d.width; }
	  if(d.height > jLayoutSizePrefY) { jLayoutSizePrefY = d.height; }
	  d = c.getMaximumSize();
	  if(d.width > jLayoutSizeMaxX) { jLayoutSizeMaxX = d.width; }
	  if(d.height > jLayoutSizeMaxY) { jLayoutSizeMaxY = d.height; }
	}
	/**
	 * Set a components size to a given minimum (save as other
	 * components).
	 *
	 * @param c
	 * The component to change.
	 */
	private void jLayoutSetSize(JComponent c)
	{
	  c.setMinimumSize(new Dimension(jLayoutSizeMinX, jLayoutSizeMinY));
	  c.setPreferredSize(new Dimension(jLayoutSizePrefX, jLayoutSizePrefY));
	  c.setMaximumSize(new Dimension(jLayoutSizeMaxX, jLayoutSizeMaxY));
	}
	/**
	 * Create GridBag constraints for a component.
	 *
	 * @param x
	 * The start grid column of the component.
	 *
	 * @param y
	 * The start grid line of the component.
	 *
	 * @param w
	 * The width of the component in grid columns.
	 *
	 * @param h
	 * The height of the component in grid lines.
	 *
	 * @param f
	 * The fill information (horizontal, vertical, both).
	 *
	 * @param wx
	 * The weight factor to grow the component horizontally
	 * when the container grows.
	 *
	 * @param wy
	 * The weight factor to grow the component vertically
	 * when the container grows.
	 */
	private GridBagConstraints jLayoutGbc(
	  int x, int y, int w, int h, int f, int a, double wx, double wy
	) {
	  GridBagConstraints back = new GridBagConstraints();
	  back.gridx = x;
	  back.gridy = y;
	  back.gridwidth = w;
	  back.gridheight = h;
	  back.fill = f;
	  back.anchor = a;
	  back.weightx = wx;
	  back.weighty = wy;
	  return back;
	}
	/**
	 * Create a dummy panel to ensure minimum distances.
	 *
	 * @param b
	 * The panels width and hight.
	 *
	 * @param rms
	 * A flag to indicate whether or not the panel must
	 * be set exactly to the given size (The panel can not grow).
	 */
	protected JPanel jLayoutCreateDistancePanel(int b, boolean rms)
	{
	  JPanel back = new JPanel();
	  Dimension d = new Dimension(b, b);
	  back.setMinimumSize(d);
	  back.setPreferredSize(d);
	  if(rms) {
	    back.setMaximumSize(d);
	  }
	  return back;
	}
	private void jLayoutSetup()
	{
	  // bCancel 187
	  bCancel = new JButton(TGS.ac[9]);
	  bCancel.setToolTipText(TGS.lt[72]);
	  bCancel.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[72]
	  );
	  // bDefaults 189
	  bDefaults = new JButton(TGS.ac[11]);
	  bDefaults.setToolTipText(TGS.lt[74]);
	  bDefaults.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[74]
	  );
	  // bOK 186
	  bOK = new JButton(TGS.ac[8]);
	  bOK.setToolTipText(TGS.lt[71]);
	  bOK.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[71]
	  );
	  // bReset 188
	  bReset = new JButton(TGS.ac[10]);
	  bReset.setToolTipText(TGS.lt[73]);
	  bReset.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[73]
	  );
	  // cbAlwaysOpenLog 23
	  cbAlwaysOpenLog = new JCheckBox(TGS.lt[15]);
	  cbAlwaysOpenLog.setToolTipText(TGS.lt[56]);
	  cbAlwaysOpenLog.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[56]
	  );
	  // cbCplusplus 53
	  cbCplusplus = new JCheckBox(TGS.lt[29]);
	  cbCplusplus.setToolTipText(TGS.lt[63]);
	  cbCplusplus.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[63]
	  );
	  // cbDebugChooseIde 67
	  cbDebugChooseIde = new JComboBox(TGS.ide);
	  cbDebugChooseIde.setToolTipText(TGS.lt[68]);
	  cbDebugChooseIde.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[68]
	  );
	  // cbDebugIde 66
	  cbDebugIde = new JCheckBox(TGS.lt[33]);
	  cbDebugIde.setToolTipText(TGS.lt[67]);
	  cbDebugIde.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[67]
	  );
	  // cbDebugStdout 65
	  cbDebugStdout = new JCheckBox(TGS.lt[32]);
	  cbDebugStdout.setToolTipText(TGS.lt[66]);
	  cbDebugStdout.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[66]
	  );
	  // cbDebugTime 68
	  cbDebugTime = new JCheckBox(TGS.lt[34]);
	  cbDebugTime.setToolTipText(TGS.lt[69]);
	  cbDebugTime.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[69]
	  );
	  // cbDebugTraceKey 69
	  cbDebugTraceKey = new JCheckBox(TGS.lt[35]);
	  cbDebugTraceKey.setToolTipText(TGS.lt[70]);
	  cbDebugTraceKey.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[70]
	  );
	  // cbDoDebug 63
	  cbDoDebug = new JCheckBox(TGS.lt[31]);
	  cbDoDebug.setToolTipText(TGS.lt[65]);
	  cbDoDebug.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[65]
	  );
	  // cbFtCpt 33
	  cbFtCpt = new JCheckBox(TGS.lt[19]);
	  cbFtCpt.setToolTipText(TGS.lt[58]);
	  cbFtCpt.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[58]
	  );
	  // cbFtCtr 30
	  cbFtCtr = new JCheckBox(TGS.lt[17]);
	  cbFtCtr.setToolTipText(TGS.lt[57]);
	  cbFtCtr.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[57]
	  );
	  // cbFtJl 42
	  cbFtJl = new JCheckBox(TGS.lt[25]);
	  cbFtJl.setToolTipText(TGS.lt[61]);
	  cbFtJl.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[61]
	  );
	  // cbFtJtr 39
	  cbFtJtr = new JCheckBox(TGS.lt[23]);
	  cbFtJtr.setToolTipText(TGS.lt[60]);
	  cbFtJtr.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[60]
	  );
	  // cbFtMtr 36
	  cbFtMtr = new JCheckBox(TGS.lt[21]);
	  cbFtMtr.setToolTipText(TGS.lt[59]);
	  cbFtMtr.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[59]
	  );
	  // cbLineNumbers 52
	  cbLineNumbers = new JCheckBox(TGS.lt[28]);
	  cbLineNumbers.setToolTipText(TGS.lt[62]);
	  cbLineNumbers.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[62]
	  );
	  // cbMakeMode 22
	  cbMakeMode = new JCheckBox(TGS.lt[14]);
	  cbMakeMode.setToolTipText(TGS.lt[55]);
	  cbMakeMode.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[55]
	  );
	  // l1FtCpt 34
	  l1FtCpt = new JLabel(TGS.lt[16]);
	  // l1FtCtr 31
	  l1FtCtr = new JLabel(TGS.lt[16]);
	  // l1FtJl 43
	  l1FtJl = new JLabel(TGS.lt[16]);
	  // l1FtJtr 40
	  l1FtJtr = new JLabel(TGS.lt[16]);
	  // l1FtMtr 37
	  l1FtMtr = new JLabel(TGS.lt[16]);
	  // l2FtCpt 35
	  l2FtCpt = new JLabel(TGS.lt[20]);
	  // l2FtCtr 32
	  l2FtCtr = new JLabel(TGS.lt[18]);
	  // l2FtJl 44
	  l2FtJl = new JLabel(TGS.lt[26]);
	  // l2FtJtr 41
	  l2FtJtr = new JLabel(TGS.lt[24]);
	  // l2FtMtr 38
	  l2FtMtr = new JLabel(TGS.lt[22]);
	  // lOutputWidth 55
	  lOutputWidth = new JLabel(TGS.lt[30]);
	  // pButtons 16
	  pButtons = new JPanel();
	  {
	    pButtons.setLayout(new BoxLayout(pButtons, BoxLayout.LINE_AXIS));
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bOK);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bCancel);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bReset);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(bDefaults);
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	    pButtons.add(Box.createHorizontalGlue());
	    pButtons.add(Box.createRigidArea(new Dimension(b, 0)));
	  }
	  // pDummy1 54
	  pDummy1 = new JPanel();
	  pDummy1.setMinimumSize(new Dimension(10, 10));
	  pDummy1.setPreferredSize(new Dimension(15, 15));
	  // pDummy2 64
	  pDummy2 = new JPanel();
	  pDummy2.setMinimumSize(new Dimension(10, 10));
	  pDummy2.setPreferredSize(new Dimension(15, 15));
	  // pFiles 14
	  pFiles = new JPanel();
	  pFiles.setBorder(
	    BorderFactory.createTitledBorder(TGS.lt[37])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pFiles.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      6, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pFiles.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbFtCtr, gbc);
	    pFiles.add(cbFtCtr);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l1FtCtr, gbc);
	    pFiles.add(l1FtCtr);
	    gbc = jLayoutGbc(
	      5, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l2FtCtr, gbc);
	    pFiles.add(l2FtCtr);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbFtCpt, gbc);
	    pFiles.add(cbFtCpt);
	    gbc = jLayoutGbc(
	      3, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l1FtCpt, gbc);
	    pFiles.add(l1FtCpt);
	    gbc = jLayoutGbc(
	      5, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l2FtCpt, gbc);
	    pFiles.add(l2FtCpt);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbFtMtr, gbc);
	    pFiles.add(cbFtMtr);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l1FtMtr, gbc);
	    pFiles.add(l1FtMtr);
	    gbc = jLayoutGbc(
	      5, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l2FtMtr, gbc);
	    pFiles.add(l2FtMtr);
	    gbc = jLayoutGbc(
	      1, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbFtJtr, gbc);
	    pFiles.add(cbFtJtr);
	    gbc = jLayoutGbc(
	      3, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l1FtJtr, gbc);
	    pFiles.add(l1FtJtr);
	    gbc = jLayoutGbc(
	      5, 7, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l2FtJtr, gbc);
	    pFiles.add(l2FtJtr);
	    gbc = jLayoutGbc(
	      1, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbFtJl, gbc);
	    pFiles.add(cbFtJl);
	    gbc = jLayoutGbc(
	      3, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l1FtJl, gbc);
	    pFiles.add(l1FtJl);
	    gbc = jLayoutGbc(
	      5, 9, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(l2FtJl, gbc);
	    pFiles.add(l2FtJl);
	  }
	  // pGeneralOptions 12
	  pGeneralOptions = new JPanel();
	  pGeneralOptions.setBorder(
	    BorderFactory.createTitledBorder(TGS.lt[36])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pGeneralOptions.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneralOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneralOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneralOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      2, 4, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneralOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pGeneralOptions.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbMakeMode, gbc);
	    pGeneralOptions.add(cbMakeMode);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbAlwaysOpenLog, gbc);
	    pGeneralOptions.add(cbAlwaysOpenLog);
	  }
	  // tfOutputWidth 56
	  tfOutputWidth = new JTextField(3);
	  tfOutputWidth.setText(TGS.lt[27]);
	  tfOutputWidth.setToolTipText(TGS.lt[64]);
	  tfOutputWidth.getAccessibleContext().setAccessibleDescription(
	    TGS.lt[64]
	  );
	  // pDebugOptions 15
	  pDebugOptions = new JPanel();
	  pDebugOptions.setBorder(
	    BorderFactory.createTitledBorder(TGS.lt[39])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pDebugOptions.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      6, 10, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 8, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pDebugOptions.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDoDebug, gbc);
	    pDebugOptions.add(cbDoDebug);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pDummy2, gbc);
	    pDebugOptions.add(pDummy2);
	    gbc = jLayoutGbc(
	      3, 3, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugStdout, gbc);
	    pDebugOptions.add(cbDebugStdout);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugIde, gbc);
	    pDebugOptions.add(cbDebugIde);
	    gbc = jLayoutGbc(
	      5, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugChooseIde, gbc);
	    pDebugOptions.add(cbDebugChooseIde);
	    gbc = jLayoutGbc(
	      3, 7, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugTime, gbc);
	    pDebugOptions.add(cbDebugTime);
	    gbc = jLayoutGbc(
	      3, 9, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbDebugTraceKey, gbc);
	    pDebugOptions.add(cbDebugTraceKey);
	  }
	  // pOutputOptions 13
	  pOutputOptions = new JPanel();
	  pOutputOptions.setBorder(
	    BorderFactory.createTitledBorder(TGS.lt[38])
	  );
	  {
	    GridBagLayout gbl = new GridBagLayout();
	    pOutputOptions.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      6, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      6, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      1.0, 1.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    pOutputOptions.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbLineNumbers, gbc);
	    pOutputOptions.add(cbLineNumbers);
	    gbc = jLayoutGbc(
	      1, 3, 5, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(cbCplusplus, gbc);
	    pOutputOptions.add(cbCplusplus);
	    gbc = jLayoutGbc(
	      1, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pDummy1, gbc);
	    pOutputOptions.add(pDummy1);
	    gbc = jLayoutGbc(
	      3, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.EAST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(lOutputWidth, gbc);
	    pOutputOptions.add(lOutputWidth);
	    gbc = jLayoutGbc(
	      5, 5, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(tfOutputWidth, gbc);
	    pOutputOptions.add(tfOutputWidth);
	  }
	  // MAIN 0
	  setTitle(TGS.lt[13]);
	  setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);
	  {
	    Container cp = null;
	    cp = getContentPane();
	    GridBagLayout gbl = new GridBagLayout();
	    cp.setLayout(gbl);
	    GridBagConstraints gbc = null;
	    JPanel dp = null;
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      0, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      4, 0, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, false);
	    gbc = jLayoutGbc(
	      4, 6, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.CENTER,
	      0.5, 0.5
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      2, 0, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 2, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    dp = jLayoutCreateDistancePanel(b, true);
	    gbc = jLayoutGbc(
	      0, 4, 1, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(dp, gbc);
	    cp.add(dp);
	    gbc = jLayoutGbc(
	      1, 1, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pGeneralOptions, gbc);
	    cp.add(pGeneralOptions);
	    gbc = jLayoutGbc(
	      3, 1, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pOutputOptions, gbc);
	    cp.add(pOutputOptions);
	    gbc = jLayoutGbc(
	      1, 3, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pFiles, gbc);
	    cp.add(pFiles);
	    gbc = jLayoutGbc(
	      3, 3, 1, 1,
	      GridBagConstraints.BOTH, GridBagConstraints.WEST,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pDebugOptions, gbc);
	    cp.add(pDebugOptions);
	    gbc = jLayoutGbc(
	      1, 5, 3, 1,
	      GridBagConstraints.NONE, GridBagConstraints.CENTER,
	      0.0, 0.0
	    );
	    gbl.setConstraints(pButtons, gbc);
	    cp.add(pButtons);
	  }
	  jLayoutResetSizes();
	  jLayoutGetSize(bCancel);
	  jLayoutGetSize(bDefaults);
	  jLayoutGetSize(bOK);
	  jLayoutGetSize(bReset);
	  jLayoutSetSize(bCancel);
	  jLayoutSetSize(bDefaults);
	  jLayoutSetSize(bOK);
	  jLayoutSetSize(bReset);
	  bCancel.addActionListener(this);
	  bDefaults.addActionListener(this);
	  bOK.addActionListener(this);
	  bReset.addActionListener(this);
	  cbDebugIde.addItemListener(this);
	  cbDoDebug.addItemListener(this);
	}
// END OF JLAYOUT SECTION
// jlayout.setup.end

// jlayout.cleanup.begin
// START OF JLAYOUT SECTION
// This section was generated automatically by the jlayout program.
// You should not modify this section.
// Any changes applied to this section will be lost if jlayout is run again.
	private void jLayoutCleanup()
	{
	  bCancel.removeActionListener(this);
	  bDefaults.removeActionListener(this);
	  bOK.removeActionListener(this);
	  bReset.removeActionListener(this);
	  cbDebugIde.removeItemListener(this);
	  cbDoDebug.removeItemListener(this);
	}
// END OF JLAYOUT SECTION
// jlayout.cleanup.end

  public TraceccOptionsDialog(JFrame f, TraceccController t, GuiController g) {
    super(f);
    tc = t; gc = g; b = gc.getBorder();
    jLayoutSetup();
    pack();
    setResizable(false);
  }


  public void cleanup() {
      jLayoutCleanup();
  }

  private void turnoff(JCheckBox cb) {
    cb.setSelected(false); cb.setEnabled(false);
  }

  private void check_enabled_components() {
    if(cbDoDebug.isSelected()) {
      cbDebugStdout.setEnabled(true);
      cbDebugIde.setEnabled(true);
      cbDebugTime.setEnabled(true);
      cbDebugTraceKey.setEnabled(true);
    } else {
      turnoff(cbDebugStdout);
      turnoff(cbDebugIde);
      turnoff(cbDebugTime);
      turnoff(cbDebugTraceKey);
    }
    if(cbDebugIde.isSelected()) {
      cbDebugChooseIde.setEnabled(true);
    } else {
      cbDebugChooseIde.setSelectedIndex(0);
      cbDebugChooseIde.setEnabled(false);
    }
  }

  private int toRange(int x, int min, int max) {
    int back = x;
    if(back < min) { back = min; }
    if(back > max) { back = max; }
    return back;
  }

  public void controller_to_dialog() {
    cbMakeMode.setSelected(tc.getBoolean(1));
    cbAlwaysOpenLog.setSelected(tc.getBoolean(0));
    cbFtCtr.setSelected(tc.getBoolean(2));
    cbFtCpt.setSelected(tc.getBoolean(3));
    cbFtMtr.setSelected(tc.getBoolean(4));
    cbFtJtr.setSelected(tc.getBoolean(5));
    cbFtJl.setSelected(tc.getBoolean(6));
    cbLineNumbers.setSelected(tc.getBoolean(7));
    cbCplusplus.setSelected(tc.getBoolean(8));
    tfOutputWidth.setText((new Integer(tc.getInt(0))).toString());
    cbDoDebug.setSelected(tc.getBoolean(9));
    cbDebugStdout.setSelected(tc.getBoolean(10));
    cbDebugIde.setSelected(tc.getBoolean(11));
    cbDebugChooseIde.setSelectedIndex(toRange(tc.getInt(1),0,(TGS.ide.length-1)));
    cbDebugTime.setSelected(tc.getBoolean(12));
    cbDebugTraceKey.setSelected(tc.getBoolean(13));
    check_enabled_components();
  }

  private void dialog_to_controller() {
    check_enabled_components(); // remove after installing item listeners
    tc.setBoolean(1, cbMakeMode.isSelected());
    tc.setBoolean(0, cbAlwaysOpenLog.isSelected());
    tc.setBoolean(2, cbFtCtr.isSelected());
    tc.setBoolean(3, cbFtCpt.isSelected());
    tc.setBoolean(4, cbFtMtr.isSelected());
    tc.setBoolean(5, cbFtJtr.isSelected());
    tc.setBoolean(6, cbFtJl.isSelected());
    tc.setBoolean(7, cbLineNumbers.isSelected());
    tc.setBoolean(8, cbCplusplus.isSelected());
    tc.setBoolean(9, cbDoDebug.isSelected());
    tc.setBoolean(10, cbDebugStdout.isSelected());
    tc.setBoolean(11, cbDebugIde.isSelected());
    tc.setBoolean(12, cbDebugTime.isSelected());
    tc.setBoolean(13, cbDebugTraceKey.isSelected());
    try {
      int i = Integer.parseInt(tfOutputWidth.getText());
      tc.setInt(0, i);
    } catch(Exception exc) { tc.setInt(0, 75); }
    tc.setInt(1, cbDebugChooseIde.getSelectedIndex());
  }

  private void set_defaults() {
    cbMakeMode.setSelected(false);
    cbAlwaysOpenLog.setSelected(false);
    cbFtCtr.setSelected(true);
    cbFtCpt.setSelected(true);
    cbFtMtr.setSelected(true);
    cbFtJtr.setSelected(true);
    cbFtJl.setSelected(true);
    cbLineNumbers.setSelected(true);
    cbCplusplus.setSelected(false);
    cbDoDebug.setSelected(false);
    tfOutputWidth.setText(TGS.lt[27]);
    check_enabled_components();
  }

  public void actionPerformed(ActionEvent e) {
    switch(StringTool.getArrayIndex(TGS.ac, e.getActionCommand())) {
      case 8: { // OK
        dialog_to_controller();
        setModal(false); setVisible(false);
      } break;
      case 9: { // Cancel
        controller_to_dialog();
        setModal(false); setVisible(false);
      } break;
      case 10: {  // Reset
        controller_to_dialog(); repaint();
      } break;
      case 11: {  // Defaults
        set_defaults(); repaint();
      } break;
    }
  }

  public void itemStateChanged(ItemEvent e) {
    check_enabled_components();
  }

}



// project tracegui
// @(#)TraceccOptionsDialog.java 1.1 07/09/08

