#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "const-c.inc"

#include <dkbf.h>

MODULE = DKrause::BitField	PACKAGE = DKrause::BitField	PREFIX = b_

INCLUDE: const-xs.inc

PROTOTYPES: ENABLE

DKrause::BitField
b_new(bits)
		size_t bits;
	PREINIT:
		dk_bitfield_t	*back = NULL;
	CODE:
		{
			back = dkbf_open(bits);
			if(back) {
				RETVAL = back;
			} else {
				XSRETURN_UNDEF;
			}
		}
	OUTPUT:
		RETVAL

void
b_DESTROY(bf)
		DKrause::BitField bf;
	CODE:
		dkbf_close(bf);

void
b_set(b,n)
		DKrause::BitField b;
		size_t n;
	CODE:
		{
			dkbf_set(b,n,1);
		}

void
b_reset(b,n)
		DKrause::BitField b;
		size_t n;
	CODE:
		{
			dkbf_set(b,n,0);
		}

int
b_get(b,n)
		DKrause::BitField b;
		size_t n;
	CODE:
		RETVAL = dkbf_get(b,n);
	OUTPUT:
		RETVAL

void
b_resetAll(b)
		DKrause::BitField b;
	CODE:
		{
			dkbf_reset(b);
		}
