# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl DKrause-BitMatrix.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 163;
BEGIN { use_ok('DKrause::BitMatrix') };

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

my $max = 9;

my $i;
my $j;
my $m;
# create matrix
$m = DKrause::BitMatrix::new($max,$max);
# set bits
for($i = 0; $i < $max; $i++) {
  for($j = 0; $j < $max; $j++) {
    if($i != $j) {
      $m->set($i,$j);
    } else {
      $m->reset($i,$j);
    }
  }
}
# Check bits
for($i = 0; $i < $max; $i++) {
  for($j = 0; $j < $max; $j++) {
    if($i != $j) {
      ok($m->get($i, $j));
    } else {
      ok(!($m->get($i,$j)));
    }
  }
}
$m->expand();
for($i = 0; $i < $max; $i++) {
  for($j = 0; $j < $max; $j++) {
    ok($m->get($i, $j));
  }
}
