
#include <dklogc.h>
#include <dkapp.h>

#include <stdio.h>

#if DK_HAVE_STDLIB_H
#include <stdlib.h>
#endif

dk_app_t *app = NULL;

static int success = 0;


static dk_key_value_t kv[] = {
  { "/msg/pan", "Test panic message!" },
  { "/msg/fat", "Test fatal error message!" },
  { "/msg/err", "Test error message." },
  { "/msg/wrn", "Test warning message." },
  { "/msg/inf", "Test informational message." },
  { "/msg/prg", "Test progress message." },
  { "/msg/dbg", "Test debug message." },
};

static char *messages[DK_KEY_VALUE_ARRAY_SIZE(kv)];

static char *an_array_of_strings[] = {
  "Jim ",
  "and Joe",
  " are drinking beer.",
};

int main(int argc, char *argv[])
{
  size_t kv_s;
  app = dkapp_open(argc, argv);
  if(app) {
    kv_s = DK_KEY_VALUE_ARRAY_SIZE(kv);
    dkapp_init_key_value(app, kv, kv_s, "h04msg", messages);
    dkapp_log_msg(app, DK_LOG_LEVEL_PANIC, &(messages[0]), 1);
    dkapp_log_msg(app, DK_LOG_LEVEL_FATAL, &(messages[1]), 1);
    dkapp_log_msg(app, DK_LOG_LEVEL_ERROR, &(messages[2]), 1);
    dkapp_log_msg(app, DK_LOG_LEVEL_WARNING, &(messages[3]), 1);
    dkapp_log_msg(app, DK_LOG_LEVEL_INFO, &(messages[4]), 1);
    dkapp_log_msg(app, DK_LOG_LEVEL_PROGRESS, &(messages[5]), 1);
    dkapp_log_msg(app, DK_LOG_LEVEL_DEBUG, &(messages[6]), 1);
    dkapp_log_msg(app, DK_LOG_LEVEL_INFO, an_array_of_strings, 3);
    success = 1;
    dkapp_close(app); app = NULL;
  }
  success = (success ? 0 : 1);
  exit(success);
  return success;
}

