
#if HAVE_CONFIG_H
#include "config.h"
#endif

#include "dk.h"

#include <stdio.h>
#if DK_HAVE_STDLIB_H
#include <stdlib.h>
#endif
#if DK_HAVE_UNISTD_H
#include <unistd.h>
#endif
#if DK_HAVE_PROCESS_H
#include <process.h>
#endif

static char str_libs[] = {
"LIBRARIES:"
#if HAVE_PNG_H
" -lpng"
#endif
#if HAVE_JPEGLIB_H
" -ljpeg"
#endif
#if HAVE_PNM_H
" -lnetpbm"
#endif
#if HAVE_TIFF_H
" -ltiff"
#endif
"\n"
};

static char str_defines[] = {
"CPPFLAGS:"
#if HAVE_PNG_H
" -DHAVE_PNG_H=1 -DDK_HAVE_PNG_H=1"
#endif
#if HAVE_JPEGLIB_H
" -DHAVE_JPEGLIB_H=1 -DDK_HAVE_JPEGLIB_H=1"
#endif
#if HAVE_PNM_H
" -DHAVE_PNM_H=1 -DDK_HAVE_PNM_H=1"
#endif
#if HAVE_TIFF_H
" -DHAVE_TIFF_H=1 -DDK_HAVE_TIFF_H=1"
#endif
#if HAVE_LZW
" -DHAVE_LZW=1 -DDK_HAVE_LZW=1"
#else
" -DHAVE_LZW=0 -DDK_HAVE_LZW=0"
#endif
"\n"
};

#if DK_HAVE_PROTOTYPES
int main(int argc, char *argv[])
#else
int main(argc, argv) int argc; char *argv[];
#endif
{
  fputs(str_defines, stdout);
  fputs(str_libs, stdout);
  exit(0); return 0;
}

#ifndef LINT
static char sccs_id[] = { "@(#)bifconf.ctr 1.8 02/03/09" };
#endif
