# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl DKrause-BitField.t'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

use Test::More tests => 25;
BEGIN { use_ok('DKrause::BitField') };

#########################

# Insert your test code below, the Test::More module is use()ed here so read
# its man page ( perldoc Test::More ) for help writing this test script.

sub run()
{ 
  my $i;
  my $b = DKrause::BitField::new(12);
  for($i = 0; $i < 12; $i++) {
    if($i % 2) {
      $b->set($i);
    } else {
      $b->reset($i);
    }
  }
  for($i = 0; $i < 12; $i++) {
    if($i % 2) {
      ok($b->get($i));
    } else {
      ok(!($b->get($i)));
    }
  }
  $b->resetAll();
  for($i = 0; $i < 12; $i++) {
    ok(!($b->get($i)));
  }
}

run();
