#! /bin/sh
echo Running prep-dist.sh
STCOPT="--/log/stderr/level=error --/log/stdout/level=none"
stc $STCOPT -p dkapp.str    share
stc $STCOPT -p dkappd.str   share
stc $STCOPT -p dkappe.str   share
stc $STCOPT -p stc.str      share/stc
stc $STCOPT -p trana.str    share/trana
stc $STCOPT -p tracecc.str  share/tracecc
stc $STCOPT -p tracecca.str share/tracecc

SRCFILESJAVA=`egrep -l '//[ \t]*project[ \t]*dklibsj' *.java`
SRCFILESJL=`egrep -l '#[ \t]*project[ \t]*dklibsj' *.jl`
SRCFILES="$SRCFILESJAVA $SRCFILESJL"

DIR=Java/dklibsj/src/dirk_krause/jtools
[ -d $DIR ] || (mkdir -p $DIR; chmod 755 $DIR)
echo mv $SRCFILES $DIR
cp $SRCFILES $DIR

DIR=Java/TraceGUI/src/dirk_krause/jtools
[ -d $DIR ] || (mkdir -p $DIR; chmod 755 $DIR)
echo mv $SRCFILES $DIR
mv $SRCFILES $DIR

SRCFILESJAVA=`egrep -l '//[ \t]*project[ \t]*tracegui' *.java`
SRCFILESJL=`egrep -l '#[ \t]*project[ \t]*tracegui' *.jl`
SRCFILES="$SRCFILESJAVA $SRCFILESJL"
DIR=Java/TraceGUI/src/traceccgui
[ -d $DIR ] || (mkdir -p $DIR; chmod 755 $DIR)
echo mv $SRCFILES $DIR
mv $SRCFILES $DIR

